unit UDisplay;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, vcl.Printers, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.StdCtrls, Vcl.Imaging.pngimage, VCLTee.TeeComma;

type
  TForm7 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Image1: TImage;
    Chart1: TChart;
    Button1: TButton;
    Label1: TLabel;
    TeeCommander1: TTeeCommander;
    procedure Button1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form7: TForm7;
  aRect : TRect;

implementation

{$R *.dfm}

const stdScr = 1920; //assuming screen is capable of 1920

procedure TForm7.Button1Click(Sender: TObject);
var mf : TMetafile;
    wd,hg : String;
    dispSize : Double;
begin
   Image1.Picture := nil;
   aRect := Image1.BoundsRect;

   wd := IntToStr(aRect.Width);
   hg := IntToStr(aRect.Height);

   Chart1.Title.Caption := 'width: ' + wd + ', height: ' + hg;
   Label1.Caption := Chart1.Title.Caption + '. (scr width:' + IntToStr(screen.width) + ')';

   //metafile size/proportions tru to original chart
   mf := Chart1.TeeCreateMetafile(false, aRect);

   //get adjusted resolution relative to std 1920x1080 screen
   dispSize := stdScr / screen.width;

   aRect:=Rect(Image1.BoundsRect.Left,Image1.BoundsRect.Top,
                     Round(Image1.BoundsRect.Right*dispSize),
                     Round(Image1.BoundsRect.Bottom*dispSize));

   //stretch metafile to render output size
   Image1.Canvas.StretchDraw(aRect,mf);
end;

procedure TForm7.FormResize(Sender: TObject);
begin
  Button1Click(self);
end;

procedure TForm7.FormShow(Sender: TObject);
begin
  Label1.Font.Size := Chart1.Title.Font.Size;
  Label1.Font.Name := Chart1.Title.Font.Name;
end;

end.


